

#import psyco
import pydfb as pygame
#import pygame
import time

CYCLES= 1000

def stretch_blit( screen, image, rect, rect1 ):
  screen.blit( image, (0,0), rect, rect1 )
  return image.get_width()* image.get_height()

def blit( screen, image, pos, rect= None ):
  if rect:
    screen.blit( image, pos, rect )
  else:
    screen.blit( image, pos )
  
  return image.get_width()* image.get_height()

def transpImage( screen ):
  bg= pygame.image.load( 'data/bg.jpg' )
  transp= pygame.image.load( 'data/transp.gif' )
  start= time.time()
  pix= 0
  for x in xrange( 0, CYCLES* 10 ):
    pix+= blit( screen, bg, (0,0) )
    pix+= blit( screen, transp, (0,0+(x % 100)) )
    pygame.display.update()

  delta= time.time()- start
  print 'Colorkeyed images: %.2f Mpix/sec' % ( pix / float( delta* 1000000 ) )

def fullImages( screen ):
  bg= pygame.image.load( 'data/bg.jpg' )
  alpha= pygame.image.load( 'data/alpha.png' )
  colorkey= pygame.image.load( 'data/colorkey.png' )
  colorkey.set_colorkey( (38,109,163) )
  start= time.time()
  pix= 0
  for x in xrange( 0, CYCLES ):
    pix+= blit( screen, bg, (0,0) )
    pix+= blit( screen, alpha, (0,0+(x % 100)) )
    pix+= blit( screen, colorkey, (0,300+(x % 100)) )
    pygame.display.update()

  delta= time.time()- start
  print 'Full images: %.2f Mpix/sec' % ( pix / float( delta* 1000000 ) )

def subImages( screen ):
  bg= pygame.image.load( 'data/bg.jpg' )
  alpha= pygame.image.load( 'data/alpha.png' )
  colorkey= pygame.image.load( 'data/colorkey.png' )
  colorkey.set_colorkey( (38,109,163) )
  pix= 0
  delta= 0
  for x in xrange( 0, CYCLES ):
    start= time.time()
    pix+= blit( screen, bg, (0,0) )
    a1= alpha.subsurface( ( 50,50,alpha.get_width()- 50,alpha.get_height()- 50 )  )
    pix+= blit( screen, a1, (0,0+(x % 100)) )
    pix+= blit( screen, colorkey, (0,300+(x % 100)), ( 1,1,colorkey.get_width()- 10,colorkey.get_height()- 10 ) )
    delta+= time.time()- start
    pygame.display.flip()

  print 'Subsurfaces images: %.2f Mpix/sec' % ( pix / float( delta* 1000000 ) )

def clipImages( screen ):
  bg= pygame.image.load( 'data/bg.jpg' )
  alpha= pygame.image.load( 'data/alpha.png' )
  start= time.time()
  pix= 0
  for x in xrange( 0, CYCLES ):
    pix+= blit( screen, bg, (0,0) )
    screen.set_clip( (100,100,100,100) )
    pix+= blit( screen, alpha, (0,0+(x % 100)) )
    pygame.display.update()

  delta= time.time()- start
  print 'Clipped images: %.2f Mpix/sec' % ( pix / float( delta* 1000000 ) )

def scaleImages( screen ):
  bg= pygame.image.load( 'data/bg.jpg' )
  screen.set_clip()
  start= time.time()
  pix= 0
  for x in xrange( CYCLES ):
    w= ( int( float(x) * 1.33333 ) % 640 )+1
    h= ( x % 480 )+1
    pix+= stretch_blit( screen, bg, (0,0, w, h ),1)
    pix+= stretch_blit( screen, bg, (0,0, 200, bg.get_height() ),(100,100,100,100))
    pygame.display.update()

  delta= time.time()- start
  print 'Scaled images: %.2f Mpix/sec' % ( pix / float( delta* 1000000 ) )

pygame.init()
screen= pygame.display.set_mode( (800,600), pygame.DOUBLEBUF, 16 )
pygame.display.flip(0)
screen.fill( (0,0,0) )
"""
# test full images blitting with pixel format autodetection
fullImages( screen )

# test subsurface images blitting with pixel format autodetection
subImages( screen )

clipImages( screen )

transpImage( screen )
"""
scaleImages( screen )

#psyco.full()
pygame.quit()


