import pydfb as pygame

def drawLines( screen, x ):
  w,h= screen.get_size()
  # Clear the screen
  pygame.draw.rect( screen, (0,0,0), (0,0,w,h))
  r= pygame.Rect( 200, 200, 200, 150+ x )
  pygame.draw.aalines( screen, (230, 80, 220), 1, ( ( 40+ x, 250 ), ( 60+ x, 270 ), ( 90+ x, 400 ), ( 80+ x, 450 ), ( 60+ x, 320 ), ( 35+ x, 280 ) ) )

def drawArcs( screen, x ):
  w,h= screen.get_size()
  # Clear the screen
  pygame.draw.rect( screen, (0,0,0), (0,0,w,h))
  r= pygame.Rect( 200, 200, 200, 150+ x )
  pygame.draw.arc( screen, (230, 180, 190), r, 0, 3.14 )

def drawEllipses( screen, x ):
  w,h= screen.get_size()
  # Clear the screen
  pygame.draw.rect( screen, (0,0,0), (0,0,w,h))
  r= pygame.Rect( 200, 200, 200, 150+ x )
  pygame.draw.ellipse( screen, (230, 180, 190), r )

def drawCircles( screen, x ):
  posx= 200+ x
  r= pygame.Rect( 200, 200, 200, 100 )
  w,h= screen.get_size()
  # Clear the screen
  pygame.draw.rect( screen, (0,0,0), (0,0,w,h))
  pygame.draw.circle( screen, (230, 180, 190), (posx,300), 80 )

def drawShapes( screen, x ):
  w,h= screen.get_size()
  # Clear the screen
  pygame.draw.rect( screen, (0,0,0), (0,0,w,h))
  # Draw filled rectangle
  pygame.draw.rect( screen, (200, 234, 120 ), ( 10+ x, 10, 100, 200 ))
  # Draw lines around the filled rectangle
  pygame.draw.rect( screen, (255, 255, 255 ), ( 9+ x, 9, 102, 202 ), 1 )
  # Draw filled polygon little lower
  pygame.draw.polygon( screen, (200, 160, 134 ), ( ( 40+ x, 250 ), ( 60+ x, 270 ), ( 90+ x, 400 ), ( 80+ x, 450 ), ( 60+ x, 320 ), ( 35+ x, 280 ) ) )

def drawBlended( screen, x ):
  w,h= screen.get_size()
  # Clear the screen
  pygame.draw.rect( screen, (0,0,0), (0,0,w,h))
  r= pygame.Rect( 200, 200, 200, 150+ x )
  posx= 200+ x
  pygame.draw.circle( screen, (230, 180, 190, 100), (posx,300), 80 )
  pygame.draw.rect( screen, (200, 234, 120, 120), ( 200+ x, 200, 100, 300 ))

import time
pygame.init()
screen= pygame.display.set_mode( (800,600), 32 )

for x in xrange( 0, 1000 ):
  drawShapes( screen, x % 200 )

for x in xrange( 0, 1000 ):
  drawCircles( screen, x % 60 )

for x in xrange( 0, 1000 ):
  drawEllipses( screen, x % 70 )

for x in xrange( 0, 1000 ):
  drawArcs( screen, x % 80 )

for x in xrange( 0, 1000 ):
  drawLines( screen, x % 50 )

for x in xrange( 0, 1000 ):
  drawBlended( screen, x % 50 )

#pygame.display.flip(0)
time.sleep( 2 )
pygame.quit()
